---
title: Tools for game development
slug: Games/Tools
tags:
  - Games
  - Gecko
  - Guide
  - JavaScript
---
<div>{{GamesSidebar}}</div>

<div class="summary">
<p><span class="seoSummary">On this page you can find links to our game development tools articles, which eventually aims to cover frameworks, compilers, and debugging tools.</span></p>
</div>

<dl>
 <dt><a href="/en-US/docs/Games/Tools/asm.js">asm.js</a></dt>
 <dd>asm.js is a very limited subset of the JavaScript language, which can be greatly optimized and run in an ahead-of-time (AOT) compiling engine for much faster performance than your typical JavaScript performance. This is, of course, great for games.</dd>
 <dt><a href="https://github.com/kripken/emscripten/wiki">Emscripten</a></dt>
 <dd>
 <p>An LLVM to JavaScript compiler; with Emscripten, you can compile C++ and other languages that can compile to LLVM bytecode into high-performance JavaScript. This is a great tool for porting applications to the Web! There is a <a href="https://github.com/kripken/emscripten/wiki/Tutorial">useful Emscripten tutorial</a> available on the wiki. Note that we are <a href="/en-US/docs/Emscripten">aiming to cover Emscripten in its own section of MDN</a>.</p>
 </dd>
 <dt><a href="https://addons.mozilla.org/en-us/firefox/addon/gecko-profiler/">Gecko profiler</a></dt>
 <dd>The Gecko profiler extension lets you profile your code to help figure out where your performance issues are so that you can make your game run at top speed.</dd>
 <dt><a href="/en-US/docs/Mozilla/Projects/Shumway">Shumway</a></dt>
 <dd>Shumway is a renderer for Adobe Flash built entirely in JavaScript, WebGL, etc., bridging the gap between Flash and web standards. This article shows how to make use of Shumway, and how to contribute fixes and bugs to the project.</dd>
 <dt>Toolchain for developing and debugging games</dt>
 <dd>How does this differ from normal web app debugging? What specialist tools are available? A lot of this is going to be covered by Will in <a href="/en-US/docs/Tools">tools</a>, but here we should provide a kind of practical toolchain tutorial for debugging games, with links to Will's stuff:
 <ul>
  <li>Basic tools overview</li>
  <li><a href="/en-US/docs/Tools/Shader_Editor">Shader editor</a></li>
  <li>Performance tools (still in production, estimated early 2014)</li>
 </ul>
 </dd>
</dl>
